#include "stdafx.h"
#include "Octonet.h"
//#include "octopus.h"

Octonet::Octonet(void)
{
	op = new Octopus_context();
}

Octonet::~Octonet(void)
{
	delete(op);
}

int Octonet::open(void)
{
	return octopus_open( op->context() );
}

int Octonet::open_id(int vendor, int product)
{
	return octopus_open_id( op->context(), vendor, product);
}

int Octonet::open_serial(char * serial)
{
	return octopus_open_serial( op->context(),serial);
}
/* Wegen den struct nicht CLR-Kompatible, wenn es ntig ist muss noch ein Wrapper geschrieben werden.
int Octonet::open_dev(struct usb_device *dev)
{
	return octopus_open_dev( op->context(), usb_device);
}
*/
int Octonet::close(void)
{
	return octopus_close( op->context() );
}

/// part: IO

int Octonet::io_init(int pin)
{
	return octopus_io_init( op->context(), pin);
}

int Octonet::io_init_port(int port)
{
	return octopus_io_init_port( op->context(), port);
}

int Octonet::io_set_port_direction_out(int port,unsigned char mask)
{
	return octopus_io_set_port_direction_out( op->context(), port, mask);;
}

int Octonet::io_set_port_direction_in(int port, unsigned char mask)
{
	return octopus_io_set_port_direction_in( op->context(), port, mask);
}

int Octonet::io_set_port_direction_tri(int port, unsigned char mask)
{
	return octopus_io_set_port_direction_tri( op->context(), port, mask);
}

int Octonet::io_set_pin_direction_out(int port)
{
	return octopus_io_set_pin_direction_out( op->context(), port);
}

int Octonet::io_set_pin_direction_in(int pin)
{
	return octopus_io_set_pin_direction_in( op->context(), pin);
}

int Octonet::io_set_pin_direction_tri(int pin)
{
	return octopus_io_set_pin_direction_tri( op->context(), pin);
}

unsigned char Octonet::io_get_port(int port)
{
	return octopus_io_get_port( op->context(), port);
}

int Octonet::io_set_port(int port, unsigned char value)
{
	return octopus_io_set_port( op->context(), port, value);
}

int Octonet::io_set_pin(int nummer, bool on_off)
{
	return octopus_io_set_pin( op->context(), nummer, (int)on_off);
}

int Octonet::io_get_pin(int pin)
{
	return octopus_io_get_pin( op->context(), pin);
}

/// part: adc

int Octonet::adc_init(int pin)
{
	return octopus_adc_init( op->context(), pin);
}

int Octonet::adc_get(int pin)
{
	return octopus_adc_get( op->context(), pin);
}

int Octonet::adc_ref(int ref)
{
	return octopus_adc_ref( op->context(), ref);
}

/// part: I2C

int Octonet::i2c_init()
{
	return octopus_i2c_init( op->context());
}
int Octonet::i2c_deinit()
{
	return octopus_i2c_deinit( op->context());
}
int Octonet::i2c_set_bitrate(int speed)
{
	return octopus_i2c_set_bitrate( op->context(), speed);
}
int Octonet::i2c_send_byte(unsigned char buf,int timeout)
{
	return octopus_i2c_send_byte( op->context(), buf);
}
int Octonet::i2c_send_byte(unsigned char buf)
{
	return octopus_i2c_send_byte( op->context(), buf);
}
int Octonet::i2c_send_bytes(unsigned char *buf, int len, int timeout)
{
	return octopus_i2c_send_bytes( op->context(), (char*)buf, len);
}
int Octonet::i2c_send_bytes(unsigned char *buf, int len)
{
	return octopus_i2c_send_bytes( op->context(), (char*)buf, len);
}
unsigned char Octonet::i2c_receive_byte(int address,int timeout)
{
	return octopus_i2c_receive_byte( op->context(), address);
}
unsigned char Octonet::i2c_receive_byte(int address)
{
	return octopus_i2c_receive_byte( op->context(), address);
}
/* ist in der orginal-dll nicht mehr Vorhanden
int Octonet::i2c_receive_bytes(int address,char *buf, int len, int timeout)
{
	return octopus_i2c_receive_bytes( op->context(), address, buf, len);
}
int Octonet::i2c_receive_bytes(int address,char *buf, int len)
{
	return octopus_i2c_receive_bytes( op->context(), address, buf, len);
}*/
int Octonet::i2c_send_start()
{
	return octopus_i2c_send_start( op->context());
}
int Octonet::i2c_send_stop()
{
	return octopus_i2c_send_stop( op->context());
}

/// part: UART

int Octonet::uart_init(int uartport)
{
	return octopus_uart_init( op->context(), uartport);
}
int Octonet::uart_deinit(int uartport)
{
	return octopus_uart_deinit( op->context(), uartport);
}
int Octonet::uart_default(int uartport) //9600 8N1
{
	return octopus_uart_init_default( op->context(), uartport);
}
int Octonet::uart_defaults(int uartport, unsigned long int baudrate, int databits, char parity, int stopbits)
{
	return octopus_uart_init_defaults( op->context(), uartport, baudrate, databits, parity, stopbits);
}
/*int Octonet::uart_speed(int uartport, int speed)
{
	return octopus_uart_speed( op->context(), uartport, speed);
}*/
int Octonet::uart_stopbits(int uartport, int stopbits)
{
	return octopus_uart_stopbits( op->context(), uartport, stopbits);
}
int Octonet::uart_databits(int uartport, int databits)
{
	return octopus_uart_databits( op->context(), uartport, databits);
}
int Octonet::uart_baudrate(int uartport, unsigned long int baudrate)
{
	return octopus_uart_baudrate( op->context(), uartport, baudrate);
}
int Octonet::uart_parity(int uartport, int parity)
{
	return octopus_uart_parity( op->context(), uartport, parity);
}
/*int Octonet::uart_putchar(int uartport, char data)
{
	return octopus_uart_putchar( op->context(), uartport, data);
}*/
int Octonet::uart_send(int uartport, unsigned char * buf, int length)
{
	return octopus_uart_send( op->context(), uartport, (char *)buf, length);
}
int Octonet::uart_recv(int uartport, unsigned char * buf, int length)
{
	return octopus_uart_recv( op->context(), uartport, (char *)buf, length);
}
/// part: SPI
int Octonet::spi_init()
{
	return -1;
}
int Octonet::spi_init(int dord, int mode, int speed)
{
	return octopus_spi_init( op->context(), dord, mode, speed);
}
int Octonet::spi_deinit()
{
	return octopus_spi_deinit( op->context() );
}
/*int Octonet::spi_speed(int speed)
{
	return octopus_spi_speed(op->context(), speed);
}*/
int Octonet::spi_send(unsigned char * buf, int length)
{
	return octopus_spi_send( op->context(), buf, length);
}
int Octonet::spi_recv(unsigned char * buf, int length)
{
	return octopus_spi_recv( op->context(), buf, length);
}
int Octonet::spi_send_and_recv(unsigned char * buf, int length)
{
	return octopus_spi_send_and_recv( op->context(), buf, length);
}
/// part:  Flash 93c46
int Octonet::e93c46_init()
{
	return octopus_93c46_init( op->context());
}
int Octonet::e93c46_deinit()
{
	return octopus_93c46_deinit( op->context());
}
int Octonet::e93c46_read(unsigned char address, int length, unsigned char * buf)
{
	return octopus_93c46_read(  op->context(), address, length, buf);
}
int Octonet::e93c46_write(unsigned char address, int length, unsigned char * buf)
{
	return octopus_93c46_write( op->context(), address, length, buf);
}

/// part:  PWM
int Octonet::pwm_init(int pin)
{
	return octopus_pwm_init( op->context(), pin);
}
int Octonet::pwm_deinit(int pin)
{
	return octopus_pwm_deinit( op->context(),pin);
}
int Octonet::pwm_speed(int pin, int speed)
{
	return octopus_pwm_speed( op->context(), pin, speed);
}
int Octonet::pwm_value(int pin, unsigned char value)
{
	return octopus_pwm_value( op->context(), pin, value);
}
// part: CAN
int Octonet::can_deinit()
{
	return octopus_can_deinit( op->context() );
}
int Octonet::can_send_remote(unsigned int mob)
{
	return octopus_can_send_remote( op->context(), mob);
}
int Octonet::can_receive_data(unsigned int mob, unsigned int *id, char *buf)
{
	return octopus_can_receive_data( op->context(), mob, id, buf);
}
int Octonet::can_init(unsigned int baudrate, unsigned int eid)
{
	return octopus_can_init( op->context(), baudrate, eid);
}
int Octonet::can_enable_mob(unsigned int mob, unsigned int mode, unsigned int id, unsigned int idm)
{
	return octopus_can_enable_mob( op->context(), mob, mode, id, idm);
}
int Octonet::can_send_data(unsigned int mob, unsigned int length, char *data)
{
	return octopus_can_send_data( op->context(), mob, length, data);
}
int Octonet::can_disable_mob(unsigned int mob)
{
	return octopus_can_disable_mob( op->context(), mob);
}
int Octonet::can_set_autoreply(unsigned int mob, unsigned int length, char *data)
{
	return octopus_can_set_autoreply( op->context(), mob, length, data);
}
